code/server/Porte_SI/config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root to: 'pages#index'

  get 'login', to: 'pages#login'

  get 'logs', to: 'pages#logs'

  get 'permissions', to: 'pages#permissions'

  resources :users

  resources :doors

  get '/doors/:id/toogle', to: 'doors#toogle'

end

code/server/Porte_SI/app/models/Log.rb
class Log < ApplicationRecord

  @content
  @date

end

code/server/Porte_SI/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

code/server/Porte_SI/app/models/door.rb
class Door < ApplicationRecord

  @name
  @ip
  @authorized_roles
  @last_user
  @is_open

end

code/server/Porte_SI/app/models/user.rb
class User < ApplicationRecord
  @name
  @mail
  @password
  @rfid
  @code
  @role

# def initialize(n, m, p, r, c, ro)
#   @name = n
#   @mail = m
#   @password = p
#   @rfid = r
#   @code = c
#   @role = ro
# end
end

code/server/Porte_SI/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :null_session
end

code/server/Porte_SI/app/controllers/doors_controller.rb
# coding: utf-8
class DoorsController < ApplicationController

  require 'httparty'

  def index
    @doors = Door.all
  end

  def show
    @door = Door.find(params[:id])
  end

  def new
    @door = Door.new
  end

  def create
    @door = Door.new
    @door.name = params[:door][:name]
    @door.ip= params[:door][:ip]
    @door.authorized_roles= params[:door][:authorized_roles]
    @door.is_open = false
    @door.save
    redirect_to "/doors/"
  end

  def edit
    @door = Door.find(params[:id])
  end

  def update
    @door = Door.find(params[:id])
    @door.name = params[:door][:name]
    @door.ip= params[:door][:ip]
    @door.authorized_roles= params[:door][:authorized_roles]
    @door.save
    redirect_to "/doors/"
  end

  def destroy
    @door = Door.find(params[:id])
    @door.destroy
    redirect_to "/doors/"
  end

  def toogle
    @door = Door.find(params[:id])
    if @door.is_open == true
      HTTParty.post("http://#{@door.ip}/" , body: {cmd: "close"})
      @door.is_open = false
      @door.save
    else
      HTTParty.post("http://#{@door.ip}/" , body: {cmd: "open"})
      @door.is_open = true
      @door.save
    end
    #Log utilisation porte
    redirect_to '/doors'
  end

end

code/server/Porte_SI/app/controllers/logs_controller.rb
class LogsController < ApplicationController

  def create
    @log = Log.new
    @log.content = params[:content]
    @log.date = Time.now
    @log.save
  end

  def destroy
    @log = Log.find(params[:id])
    @log.destroy
  end

  def index
    @logs = Log.all
  end

end

code/server/Porte_SI/app/controllers/pages_controller.rb
class PagesController < ApplicationController

  def index
    @doors = Door.all
  end

  def login
  end

  def logs
  end

end

code/server/Porte_SI/app/controllers/users_controller.rb
class UsersController < ApplicationController

  def index
    @users = User.all
  end

  def new
    @user = User.new()
  end

  def create
    key = "ThERe@llyIncReDiblyippRessiveSupERkEynumBeR256"

    @user = User.new
    @user.name = params[:user][:name]
    @user.mail = params[:user][:mail]
    @user.password = OpenSSL::HMAC.hexdigest(OpenSSL::Digest.new('sha1'), key, params[:user][:password])
    @user.rfid = OpenSSL::HMAC.hexdigest(OpenSSL::Digest.new('sha1'), key, params[:user][:rfid])
    @user.code = OpenSSL::HMAC.hexdigest(OpenSSL::Digest.new('sha1'), key, params[:user][:code])
    @user.role = params[:user][:role]
    @user.save

    redirect_to "/users/"
  end

  def show
    @user = User.find(params[:id]).name
  end

  def edit
    @user =  User.find(params[:id])
  end

  def destroy
    @user = User.find(params[:id])
    @user.destroy
    redirect_to "/users/"
  end

  def update
    key = "ThERe@llyIncReDiblyippRessiveSupERkEynumBeR256"

    @user = User.find(params[:id])
    @user.name = params[:user][:name]
    @user.mail = params[:user][:mail]
    @user.password = OpenSSL::HMAC.hexdigest(OpenSSL::Digest.new('sha1'), key, params[:user][:password])
    @user.rfid = OpenSSL::HMAC.hexdigest(OpenSSL::Digest.new('sha1'), key, params[:user][:rfid])
    @user.code = OpenSSL::HMAC.hexdigest(OpenSSL::Digest.new('sha1'), key, params[:user][:code])
    @user.role = params[:user][:role]
    @user.save

    redirect_to "/users/"
  end

end

code/server/Porte_SI/app/helpers/application_helper.rb
module ApplicationHelper
end

code/server/Porte_SI/app/helpers/doors_helper.rb
module DoorsHelper
end

code/server/Porte_SI/app/helpers/logs_helper.rb
module LogsHelper
end

code/server/Porte_SI/app/views/doors/edit.html.erb
<h1>Modifier</h1>

<%= form_for @door do |f| %>
	<label>Nom : </label>
	<%= f.text_field :name, class: "name", value: @door.name %>
	<label>Addresse IP : </label>
	<%= f.text_field :ip, class: "ip", value: @door.ip %>
	<label>Roles authorisés</label>
	<%= f.text_field :authorized_roles, class: "authorized_roles"%>
	<span>
	<input name="submit" id="submit" type="submit" value="Valider"/>
	<a href="/doors"><input id="cancel_button" name="cancel_button" type="button" value="Annuler"/></a>
	</span>
<% end %>

code/server/Porte_SI/app/views/doors/index.html.erb
<head>
    <%= stylesheet_link_tag 'pages', media: 'all', 'data-turbolinks-track': 'reload' %>
</head>
<div class="content">
    <h1>Portes</h1>
    <a href="/doors/new" class="blue-btn">Ajouter une porte</a>
    <ul>
        <% @doors.each do |door| %>
            <li>
                <p><%= door.name %></p>
                <input class="cmd" name="user_id" type="text" value="<%= door.id %>"/>
                <%if door.is_open == true %>
                    <a href="<%= "/doors/#{door.id}/toogle" %>" class="blue-btn">Fermer</a>
                <%else%>
                    <a href="<%= "/doors/#{door.id}/toogle" %>" class="blue-btn">Ouvrir</a>
                <%end%>
                <a href="<%= "/doors/#{door.id}/edit" %>" class="blue-btn">Editer</a>
                <a href="<%= door_path(door.id) %>" class="red-btn" data-confirm="Supprimer <%= door.name %> ?" data-method="DELETE" >Supprimmer</a>
            </li>
        <% end %>
    </ul>
</div>

code/server/Porte_SI/app/views/doors/new.html.erb
<h1>Ajouter</h1>

<%= form_for @door do |f| %>
	  <label>Nom : </label>
	  <%= f.text_field :name, class: "name"%>
	  <label>Addresse IP : </label>
	  <%= f.text_field :ip, class: "ip"%>
	  <label>Roles authorisés</label>
	  <%= f.text_field :authorized_roles, class: "authorized_roles"%>
	  <span>
	      <input name="submit" id="submit" type="submit" value="Valider"/>
	      <a href="/doors"><input id="cancel_button" name="cancel_button" type="button" value="Annuler"/></a>
	  </span>
<% end %>

code/server/Porte_SI/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>PorteSi</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'style', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= stylesheet_link_tag 'form', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'app', 'data-turbolinks-track': 'reload' %>
  </head>

    <body>

        <div class="cmd_panel">
            <nav>
                <p>DASHBOARD</p>
                <a href='/'>Accueil</a>
                <a href='/users'>Utilisateurs</a>
                <a href='/doors'>Portes</a>
                <a href='/permissions'>Permissions</a>
                <a href='/logs'>Logs</a>
                <p>AUTRES</p>
                <a href='/login'>Se déconnecter</a>
                <a href=''>Paramètres</a>
                <a href=''>Support</a>
                <a href=''>Infos</a>
            </nav>
        </div>
        <div class="main">
            <div class="header">
                <header>
                    <h6>SHARK DOORS PANEL</h6>
                    <h2>Accueil</h2>
                </header>
            </div>

            <%= yield %>

        </div>

    </body>
</html>

code/server/Porte_SI/app/views/pages/index.html.erb
<div class="bars">
	  <div class="logs">
		    <div><h3> logs </h3></div>
		    <div>
			      <p> log 4 </p>
			      <p> log 1 </p>
			      <p> log 2 </p>
			      <p> log 3 </p>
			      <p> log 4 </p>
			      <p> log 3 </p>
			      <p> log 4 </p>
		    </div>
	  </div>
	  <div class="door_status">
		    <div><h3> Statut portes</h3></div>
		    <div class="doors_list">

            <% @doors.each do |d| %>
                <div class="status">
                    <div class="door_icon">
                        <%if d.is_open == true%>
                            <%= image_tag("089-opened_door.png") %>
                        <% else %>
                            <%= image_tag("090-closed_door.png") %>
                        <%end%>
                    </div>
                    <div class="door_infos">
                        <span class="wifi-icon"><%= image_tag("056-low-signal-indicator.png")%><p><%= d.name %></p></span>
                        <!--            <span><%= image_tag("077-unlocked-padlock.png") %><p>Unlocked</p></span> -->
                        <span><%= image_tag("003-history-clock-button.png") %><p><%= d.last_user %></p></span>
                    </div>
                    <div class="settings_icon">
                        <a href="<%= "http://localhost:3000/doors/#{d.id}/edit" %>"><%= image_tag("025-adjust.png") %></a>
                    </div>
                </div>
            <% end %>

		    </div>
	  </div>
</div>

code/server/Porte_SI/app/views/pages/login.html.erb
<div>
	<%= image_tag("034-off.png") %>
	<h1>Nom entreprise</h1>
</div>

<form>
	<label for="id">Identifiant</></label>
	<input type="text" id="id" name="id"></input>
	<label for="password">Mot de passe</label>
	<input type="password" id="password" name="password"></input>
	<span>
		<div>
			<label for="keep_logged">Rester connecté</label>
			<input type="checkbox" id="keep_logged" name="keep_logged"></input>
		</div>
		<input type="submit" value="Se connecter"></input>
	</span>
</form>

code/server/Porte_SI/app/views/pages/logs.html.erb
<head>
	<%= stylesheet_link_tag 'pages', media: 'all', 'data-turbolinks-track': 'reload' %>
</head>

<div class="content">
	<div class="title_bar">
		<%= image_tag("028-list-1.png") %>
		<%= image_tag("014-show-more-button-with-three-dots.png") %>
	</div>
	<div class="bars">
		<div class="logs">
			<div>
				<p> <%= image_tag("005-play-arrow.png") %> log 1 </p>
				<p> <%= image_tag("005-play-arrow.png") %> log 1 </p>
				<p> <%= image_tag("005-play-arrow.png") %> log 1 </p>
				<p> <%= image_tag("005-play-arrow.png") %> log 1 </p>
				<p> <%= image_tag("005-play-arrow.png") %> log 1 </p>
				<p> <%= image_tag("005-play-arrow.png") %> log 1 </p>
			</div>
		</div>
		<div class="filters">
			<h3>Filtres</h2>
			<span>
				<label for="error_filter">Erreurs</label>
				<input type="checkbox" id="error_filter" name="error_filter"></input>
			</span>
			<span>
				<label for="open_filter">Ouvertures</label>
				<input type="checkbox" id="open_filter" name="open_filter"></input>
			</span>
			<span>
				<label for="close_filter">Fermetures</label>
				<input type="checkbox" id="close_filter" name="close_filter"></input>
			</span>
			<span>
				<label for="door">Porte n</label>
				<input type="checkbox" id="door_filter" name="door_filter"></input>
			</span>
		</div>
	</div>
</div>

code/server/Porte_SI/app/views/pages/permissions.html.erb
<head>
    <%= stylesheet_link_tag 'pages', media: 'all', 'data-turbolinks-track': 'reload' %>
</head>

<div class="content">
		<div class="title_bar">
			  <%= image_tag("028-list-1.png") %>
			  <%= image_tag("014-show-more-button-with-three-dots.png") %>
		</div>
		<div class="bars">
			  <div class="roles_list">
				    <p>Administration</p>
				    <p>Ressources humaines</p>
				    <p>Securité</p>
				    <p>Cadres</p>
				    <p>Maintenance</p>
				    <p>Entretient</p>
				    <p>Agents</p>
			  </div>
			  <div class="filters">
				    <h3><%= image_tag("006-drop-down-arrow.png") %>Serveur</h3>
				    <span>
					      <label for="users_perms">Gestion des utilisateurs</label>
					      <input type="checkbox" id="users_perms" name="users_perms"></input>
				    </span>
				    <span>
					      <label for="permissions_perms">Gestion des permissions</label>
					      <input type="checkbox" id="permissions_perms" name="permissions_perms"></input>
				    </span>
				    <span>
					      <label for="acces_perms">Gestion des accès</label>
					      <input type="checkbox" id="acces_perms" name="acces_perms"></input>
				    </span>
				    <span>
					      <label for="logs_perms">Accès aux logs</label>
					      <input type="checkbox" id="logs_perms" name="logs_perms"></input>
				    </span>

				    <h3><%= image_tag("006-drop-down-arrow.png") %>Porte n</h3>
				    <span>
					      <label for="code_filter">Ouverture Digicode</label>
					      <input type="checkbox" id="code_filter" name="code_filter"></input>
				    </span>
				    <span>
					      <label for="rfid_perms">Ouverture RFID</label>
					      <input type="checkbox" id="rfid_perms" name="rfid_perms"></input>
				    </span>

            <span>
                <button>Sauvegarder</button>
                <%= image_tag("007-save-button.png") %>
            </span>
            <span>
                <button>Annuler</button>
                <%= image_tag("013-clear-button.png") %>
            </span>
			  </div>
			  <div class="widget_agenda">
				    le widget
			  </div>
		</div>
</div>

code/server/Porte_SI/app/views/users/create.html.erb
create

code/server/Porte_SI/app/views/users/destroy.html.erb
destroy

code/server/Porte_SI/app/views/users/edit.html.erb
<h1>Modifier</h1>

<%= form_for @user do |f| %>
	<label>Nom : </label>
	<%= f.text_field :name, class: "name", value: @user.name %>
	<label for="mail">Email : </label>
	<%= f.text_field :mail, class: "mail", value: @user.mail %>
	<label for="password">Mot de passe : </label>
	<%= f.password_field :password, class: "password", value: "" %>
	<label for="rfid">RFID : </label>
	<%= f.password_field :rfid, class: "rfid", value: "" %>
	<label for="code">Digicode : </label>
	<%= f.password_field :code, class: "code", value: "" %>
	<label for="role">Role: </label>
  <%= f.select :role, ["Administration", "Ressources humaines", "Sécurité", "Cadres", "Maintenance", "Entretient", "Agents"], class: "role" %>
	<span>
	<input name="submit" id="submit" type="submit" value="Valider"/>
	<a href="/users"><input id="cancel_button" name="cancel_button" type="button" value="Annuler"/></a>
	</span>
<% end %>

code/server/Porte_SI/app/views/users/index.html.erb
<head>
    <%= stylesheet_link_tag 'pages', media: 'all', 'data-turbolinks-track': 'reload' %>
</head>
<div class="content">
    <h1>Utilisateurs</h1>
    <a href="/users/new" class="blue-btn">Ajouter un utilisateur</a>
    <ul>
        <% @users.each do |u| %>
            <li>
                <p><%= u.name %></p>
                <input class="cmd" name="user_id" type="text" value="<%= u.id %>"/>
                <a href="<%= "/users/#{u.id}/edit" %>" class="blue-btn">Editer</a>
                <a href="<%= user_path(u.id) %>" class="red-btn" data-confirm="Supprimer <%= u.name %> ?" data-method="DELETE" >Supprimmer</a>
            </li>
        <% end %>
    </ul>
</div>

code/server/Porte_SI/app/views/users/new.html.erb
<%= form_for @user do |f| %>
	<label>Nom : </label>
	<%= f.text_field :name, class: "name" %>
	<label for="mail">Email : </label>
	<%= f.text_field :mail, class: "mail" %>
	<label for="password">Mot de passe : </label>
	<%= f.password_field :password, class: "password" %>
	<label for="rfid">RFID : </label>
	<%= f.password_field :rfid, class: "rfid" %>
	<label for="code">Digicode : </label>
	<%= f.password_field :code, class: "code" %>
	<label for="role">Role: </label>
  <%= f.select :role, ["Administration", "Ressources humaines", "Sécurité", "Cadres", "Maintenance", "Entretient", "Agents"], class: "role" %>
	<span>
	<input name="submit" id="submit" type="submit" value="Valider"/>
		<a href="/"><input id="cancel_button" name="cancel_button" type="button" value="Annuler"/></a>
	</span>
<% end %>

code/server/Porte_SI/app/views/users/show.html.erb
<span>
    <%= @user %>
</span>

code/server/Porte_SI/app/views/users/update.html.erb
update